﻿using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using Stimulsoft.Report;

namespace StimulsoftWpfStyleIssue
{
    internal class MainWindowViewModel : INotifyPropertyChanged
    {
        private INotifyPropertyChanged _currentTab;
        public event PropertyChangedEventHandler PropertyChanged;

        public ObservableCollection<INotifyPropertyChanged> Tabs { get; } = new ObservableCollection<INotifyPropertyChanged>();

        public INotifyPropertyChanged CurrentTab
        {
            get => _currentTab;
            set
            {
                _currentTab = value; 
                OnPropertyChanged();
            }
        }

        public MainWindowViewModel()
        {
            StiOptions.Print.AllowUsePaperSizesFromPrinterSettings = false;

            // This option breaks the styling of the Telerik tab control
            //StiOptions.Wpf.LoadThemeMode = StiLoadThemeMode.OnceForTheWholeApp;

            // This option seems to work
            StiOptions.Wpf.LoadThemeMode = StiLoadThemeMode.ForEveryOpenedWindow;
        }

        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        public void AddTab()
        {
            Tabs.Add(new TestViewModel());
            CurrentTab = Tabs.Last();
        }
    }
}