﻿// Copyright 2011-2020 ReflexSystems

using System.ComponentModel;
using System.Runtime.CompilerServices;
using Stimulsoft.Report;

namespace StimulsoftWpfStyleIssue
{
    internal class TestViewModel : INotifyPropertyChanged
    {
        private string _displayName;
        private StiReport _report;

        public string DisplayName
        {
            get => _displayName;
            set
            {
                _displayName = value;
                OnPropertyChanged();
            }
        }

        public bool HasReport => this.Report != null;

        public StiReport Report
        {
            get => _report;
            set
            {
                _report = value;
                OnPropertyChanged();
                OnPropertyChanged(nameof(HasReport));
            }
        }

        public TestViewModel()
        {
            this.DisplayName = "Test 1234";
            var stiReport = StiReport.GetReport();
            stiReport.LoadPackedDocument("salesorderpicklist.mrt");
            this.Report = stiReport;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}